---
title: Update an AI custom ruleset
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Static Analysis
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Update an AI custom ruleset{% #update-an-ai-custom-ruleset %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                                          |
| ----------------- | ------------------------------------------------------------------------------------- |
| ap1.datadoghq.com | PATCH https://api.ap1.datadoghq.com/api/v2/static-analysis/ai/rulesets/{ruleset_name} |
| ap2.datadoghq.com | PATCH https://api.ap2.datadoghq.com/api/v2/static-analysis/ai/rulesets/{ruleset_name} |
| app.datadoghq.eu  | PATCH https://api.datadoghq.eu/api/v2/static-analysis/ai/rulesets/{ruleset_name}      |
| app.ddog-gov.com  | PATCH https://api.ddog-gov.com/api/v2/static-analysis/ai/rulesets/{ruleset_name}      |
| us2.ddog-gov.com  | PATCH https://api.us2.ddog-gov.com/api/v2/static-analysis/ai/rulesets/{ruleset_name}  |
| uk1.datadoghq.com | PATCH https://api.uk1.datadoghq.com/api/v2/static-analysis/ai/rulesets/{ruleset_name} |
| app.datadoghq.com | PATCH https://api.datadoghq.com/api/v2/static-analysis/ai/rulesets/{ruleset_name}     |
| us3.datadoghq.com | PATCH https://api.us3.datadoghq.com/api/v2/static-analysis/ai/rulesets/{ruleset_name} |
| us5.datadoghq.com | PATCH https://api.us5.datadoghq.com/api/v2/static-analysis/ai/rulesets/{ruleset_name} |

### Overview

Update the description of an existing AI custom ruleset.

### Arguments

#### Path Parameters

| Name                           | Type   | Description       |
| ------------------------------ | ------ | ----------------- |
| ruleset_name [*required*] | string | The ruleset name. |

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field             | Type   | Description                                                        |
| ------------ | ----------------- | ------ | ------------------------------------------------------------------ |
|              | data              | object | Request data for updating an AI custom ruleset.                    |
| data         | attributes        | object | Attributes for updating an AI custom ruleset.                      |
| attributes   | description       | string | Base64-encoded full description of the ruleset.                    |
| attributes   | name              | string | The ruleset name.                                                  |
| attributes   | short_description | string | Base64-encoded short description of the ruleset.                   |
| data         | id                | string | The ruleset identifier.                                            |
| data         | type              | enum   | AI custom ruleset resource type. Allowed enum values: `ai_ruleset` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "description": "Ruleset description",
      "name": "my-ai-ruleset",
      "short_description": "Ruleset short description"
    },
    "id": "my-ai-ruleset",
    "type": "ai_ruleset"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
Successfully updated
{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="412" %}
Precondition Failed - validation error or ruleset not found
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="500" %}
Internal Server Error
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Path parameters export ruleset_name="my-ai-ruleset" \# Curl command curl -X PATCH "https://api.datadoghq.com/api/v2/static-analysis/ai/rulesets/${ruleset_name}" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "description": "Ruleset description",
      "name": "my-ai-ruleset",
      "short_description": "Ruleset short description"
    },
    "id": "my-ai-ruleset",
    "type": "ai_ruleset"
  }
}
EOF 
                
##### 

```python
"""
Update an AI custom ruleset returns "Successfully updated" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.static_analysis_api import StaticAnalysisApi
from datadog_api_client.v2.model.ai_custom_ruleset_data_type import AiCustomRulesetDataType
from datadog_api_client.v2.model.ai_custom_ruleset_update_attributes import AiCustomRulesetUpdateAttributes
from datadog_api_client.v2.model.ai_custom_ruleset_update_data import AiCustomRulesetUpdateData
from datadog_api_client.v2.model.ai_custom_ruleset_update_request import AiCustomRulesetUpdateRequest

body = AiCustomRulesetUpdateRequest(
    data=AiCustomRulesetUpdateData(
        attributes=AiCustomRulesetUpdateAttributes(
            description="Ruleset description",
            name="my-ai-ruleset",
            short_description="Ruleset short description",
        ),
        id="my-ai-ruleset",
        type=AiCustomRulesetDataType.AI_RULESET,
    ),
)

configuration = Configuration()
configuration.unstable_operations["update_ai_custom_ruleset"] = True
with ApiClient(configuration) as api_client:
    api_instance = StaticAnalysisApi(api_client)
    api_instance.update_ai_custom_ruleset(ruleset_name="my-ai-ruleset", body=body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
##### 

```ruby
# Update an AI custom ruleset returns "Successfully updated" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.update_ai_custom_ruleset".to_sym] = true
end
api_instance = DatadogAPIClient::V2::StaticAnalysisAPI.new

body = DatadogAPIClient::V2::AiCustomRulesetUpdateRequest.new({
  data: DatadogAPIClient::V2::AiCustomRulesetUpdateData.new({
    attributes: DatadogAPIClient::V2::AiCustomRulesetUpdateAttributes.new({
      description: "Ruleset description",
      name: "my-ai-ruleset",
      short_description: "Ruleset short description",
    }),
    id: "my-ai-ruleset",
    type: DatadogAPIClient::V2::AiCustomRulesetDataType::AI_RULESET,
  }),
})
p api_instance.update_ai_custom_ruleset("my-ai-ruleset", body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
##### 

```go
// Update an AI custom ruleset returns "Successfully updated" response

package main

import (
	"context"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.AiCustomRulesetUpdateRequest{
		Data: &datadogV2.AiCustomRulesetUpdateData{
			Attributes: &datadogV2.AiCustomRulesetUpdateAttributes{
				Description:      datadog.PtrString("Ruleset description"),
				Name:             datadog.PtrString("my-ai-ruleset"),
				ShortDescription: datadog.PtrString("Ruleset short description"),
			},
			Id:   datadog.PtrString("my-ai-ruleset"),
			Type: datadogV2.AICUSTOMRULESETDATATYPE_AI_RULESET.Ptr(),
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.UpdateAiCustomRuleset", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewStaticAnalysisApi(apiClient)
	r, err := api.UpdateAiCustomRuleset(ctx, "my-ai-ruleset", body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `StaticAnalysisApi.UpdateAiCustomRuleset`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
##### 

```java
// Update an AI custom ruleset returns "Successfully updated" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.StaticAnalysisApi;
import com.datadog.api.client.v2.model.AiCustomRulesetDataType;
import com.datadog.api.client.v2.model.AiCustomRulesetUpdateAttributes;
import com.datadog.api.client.v2.model.AiCustomRulesetUpdateData;
import com.datadog.api.client.v2.model.AiCustomRulesetUpdateRequest;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.updateAiCustomRuleset", true);
    StaticAnalysisApi apiInstance = new StaticAnalysisApi(defaultClient);

    AiCustomRulesetUpdateRequest body =
        new AiCustomRulesetUpdateRequest()
            .data(
                new AiCustomRulesetUpdateData()
                    .attributes(
                        new AiCustomRulesetUpdateAttributes()
                            .description("Ruleset description")
                            .name("my-ai-ruleset")
                            .shortDescription("Ruleset short description"))
                    .id("my-ai-ruleset")
                    .type(AiCustomRulesetDataType.AI_RULESET));

    try {
      apiInstance.updateAiCustomRuleset("my-ai-ruleset", body);
    } catch (ApiException e) {
      System.err.println("Exception when calling StaticAnalysisApi#updateAiCustomRuleset");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
##### 

```rust
// Update an AI custom ruleset returns "Successfully updated" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_static_analysis::StaticAnalysisAPI;
use datadog_api_client::datadogV2::model::AiCustomRulesetDataType;
use datadog_api_client::datadogV2::model::AiCustomRulesetUpdateAttributes;
use datadog_api_client::datadogV2::model::AiCustomRulesetUpdateData;
use datadog_api_client::datadogV2::model::AiCustomRulesetUpdateRequest;

#[tokio::main]
async fn main() {
    let body = AiCustomRulesetUpdateRequest::new().data(
        AiCustomRulesetUpdateData::new()
            .attributes(
                AiCustomRulesetUpdateAttributes::new()
                    .description("Ruleset description".to_string())
                    .name("my-ai-ruleset".to_string())
                    .short_description("Ruleset short description".to_string()),
            )
            .id("my-ai-ruleset".to_string())
            .type_(AiCustomRulesetDataType::AI_RULESET),
    );
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.UpdateAiCustomRuleset", true);
    let api = StaticAnalysisAPI::with_config(configuration);
    let resp = api
        .update_ai_custom_ruleset("my-ai-ruleset".to_string(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * Update an AI custom ruleset returns "Successfully updated" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.updateAiCustomRuleset"] = true;
const apiInstance = new v2.StaticAnalysisApi(configuration);

const params: v2.StaticAnalysisApiUpdateAiCustomRulesetRequest = {
  body: {
    data: {
      attributes: {
        description: "Ruleset description",
        name: "my-ai-ruleset",
        shortDescription: "Ruleset short description",
      },
      id: "my-ai-ruleset",
      type: "ai_ruleset",
    },
  },
  rulesetName: "my-ai-ruleset",
};

apiInstance
  .updateAiCustomRuleset(params)
  .then((data: any) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"
{% /tab %}
